unit datamaintutor2;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, ZConnection, ZDataset, ZSqlProcessor, ZSqlMonitor,
  ZSqlUpdate;

type

  { TDataDMTutor2 }

  TDataDMTutor2 = class(TDataModule)
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DataSourceQQAllCointacts: TDataSource;
    DataSourceQQSearch: TDataSource;
    DataSourceQQAdress: TDataSource;
    DataSourceQQContact: TDataSource;
    DataSourceUpdate: TDataSource;
    DataSourceQuery: TDataSource;
    ZConnection1: TZConnection;
    ZQuery1: TZQuery;
    ZQuery2: TZQuery;
    ZQueryQQAllCointacts: TZQuery;
    ZQueryQQAdressADRESSID: TLargeintField;
    ZQueryQQAdressADRESSLINE1: TStringField;
    ZQueryQQAdressADRESSLINE2: TStringField;
    ZQueryQQAdressCITY: TStringField;
    ZQueryQQAdressCOMPANY: TStringField;
    ZQueryQQAdressCOUNTRY: TStringField;
    ZQueryQQAdressNAME1: TStringField;
    ZQueryQQAdressNAME2: TStringField;
    ZQueryQQAdressPOSTCODE: TStringField;
    ZQueryQQAdressSURNAME: TStringField;
    ZQueryQQAllCointactsADRESSID: TLargeintField;
    ZQueryQQAllCointactsCONTACTID: TLargeintField;
    ZQueryQQAllCointactsCONTENT1: TStringField;
    ZQueryQQAllCointactsCONTENT2: TStringField;
    ZQueryQQAllCointactsTITLE: TStringField;
    ZQueryQQContactADRESSID: TLargeintField;
    ZQueryQQContactCONTACTID: TLargeintField;
    ZQueryQQContactCONTENT1: TStringField;
    ZQueryQQContactCONTENT2: TStringField;
    ZQueryQQContactTITLE: TStringField;
    ZQueryQQSearch: TZQuery;
    ZQueryQQAdress: TZQuery;
    ZQueryQQContact: TZQuery;
    ZQueryQQSearchADRESSID: TLargeintField;
    ZQueryQQSearchCITY: TStringField;
    ZQueryQQSearchCONTACTID: TLargeintField;
    ZQueryQQSearchCONTENT1: TStringField;
    ZQueryQQSearchCOUNTRY: TStringField;
    ZQueryQQSearchNAME1: TStringField;
    ZQueryQQSearchSURNAME: TStringField;
    ZQueryQQSearchTITLE: TStringField;
    ZQueryUpdate: TZQuery;
    ZQueryQuery: TZQuery;
    ZQueryExport: TZQuery;
    ZSQLMonitor1: TZSQLMonitor;
    ZSQLProcessor1: TZSQLProcessor;
    ZUpdateSQLUpdate: TZUpdateSQL;
    procedure ZQuery1AfterPost(DataSet: TDataSet);
    procedure QueryRefresh(qry: TZQuery);
    procedure ZQuery1BeforeDelete(DataSet: TDataSet);
    procedure ZQuery2AfterInsert(DataSet: TDataSet);
    procedure ZQuery2AfterPost(DataSet: TDataSet);
    procedure ZQueryUpdateBeforeInsert(DataSet: TDataSet);
    procedure ZUpdateSQLUpdateBeforeInsertSQL(Sender: TObject);
  private

  public

  end;

var
  DataDMTutor2: TDataDMTutor2;

implementation

{ not in uses after interface, makes Error:                                    }
{ Circular unit reference between datamaintutor2 and MainTutor2                }
{ must give there, when you call Komponents from MainTutor2                    }
{ maybe same as for "FormMainTutor2.LabelTest.Caption" in line 118 for test    }
// uses MainTutor2;

{ **************************************************************************** }
{ * QueryRefresh                                                             * }
{ **************************************************************************** }
procedure TDataDMTutor2.QueryRefresh(qry: TZQuery);

Var  bm: TBookmark;

begin
  { übergebene ZQuery mit with generell zugängig machen }
  { make passed ZQuery generally accessible with        }
  with qry do begin
    // Die Position des neu angelegten Datensatze im Bookmark bm merken
    // memorize the position of the newly created record in Bookmark bm
    bm:= Bookmark;
    { in einen try/except Block packen                         }
    { damit die Verbindung zur Anzeige wieder hergestellt wird }
    { pack in a try / except block to reconnect to the ad      }
    try
      { keine Verbindung zu den Anzeigeelementen, spart Zeit und ruckelt nicht }
      { no connection to the display elements, saves time and does not jerk    }
      DisableControls;
      { Die Daten werden neu eingelesen, damit kann der neu erstellte Datensatz }
      { auch für Verknüpfungen verwendet werden                                 }
      { Es würde jetzt der erste Datensatz der Datenmenge angezeigt             }
      { The data will be read in again so that the newly created data set, also }
      { used for shortcuts, the first record of the dataset would now be        }
      { displayed                                                               }
      Refresh;
      { und den Datensatzzeiger auf den gerade angelegten Datensatz legen }
      { and place the record pointer on the record you just created       }
      Bookmark:= bm;
      { Sollte bis hier etwas schief gehen wird auf jeden Fall die Daten wieder }
      { mit der Anzeige verbunden                                               }
      { Should something go wrong here, the data will definitely be back        }
      { connected to the ad                                                     }

    finally
      { Verbindung herstellen }
      {Connect }
      EnableControls;
    end;
  end;
end;



{ **************************************************************************** }
{ * TDataDMTutor2.ZQuery2AfterInsert zum schnellen Datenerfassen             * }
{ **************************************************************************** }
procedure TDataDMTutor2.ZQuery2AfterInsert(DataSet: TDataSet);

begin
     // Bei jedem neu angelegten Datensatz wird der Text 'Email' in Title erfasst
     // if ZQuery2.State in [dsEdit, dsInsert] then
     //     ZQuery2.FieldByName('TITLE').AsString:= 'Handy'; // Email ...
end;


{ **************************************************************************** }
{ * TDataDMTutor2.ZQuery2AfterPost(DataSet: TDataSet)                        * }
{ **************************************************************************** }
procedure TDataDMTutor2.ZQuery2AfterPost(DataSet: TDataSet);

begin
  // Aufruf der Procedure QueryRefresh
  // Call the Procedure QueryRefresh
  QueryRefresh(DataSet as TZQuery);
end;

{ for give in Demodata }
procedure TDataDMTutor2.ZQueryUpdateBeforeInsert(DataSet: TDataSet);
begin
  // ? Adressnummer schreiben
end;

procedure TDataDMTutor2.ZUpdateSQLUpdateBeforeInsertSQL(Sender: TObject);
begin
  // ?   Adressnummer schreiben
end;

// uses  MainTutor2;

{$R *.lfm}

{ TDataDMTutor2 }


{ **************************************************************************** }
{ * ZQuery1AfterPost                                                         * }
{ **************************************************************************** }
procedure TDataDMTutor2.ZQuery1AfterPost(DataSet: TDataSet);

//var bi: string;

begin

  // Aufruf der Procedure QueryRefresh
  // Call the Procedure QueryRefresh
  QueryRefresh(DataSet as TZQuery);

  // Abfrage der Nummer des zuletzt eingefügten/geänderten Datensatzes
  // Query the number of the last inserted / changed record

  // bi := Dataset.FieldByName('ADRESSID').AsString;
  // FormMainTutor2.LabelTest.Caption:= bi;

end;

{ **************************************************************************** }
{ * ZQuery1BeforeDelete                                                      * }
{ **************************************************************************** }
procedure TDataDMTutor2.ZQuery1BeforeDelete(DataSet: TDataSet);

var i: integer;

begin

  { Bevor die Daten von ADRESS gelöscht werden,}
  { müssen die von CONTACT gelöscht werden     }
  {Before deleting the data from ADRESS,       }
  {must be deleted data from CONTACT           }
  with (DataSet as TZQuery) do begin
    { Anzeige vorübergehend blockieren  }
    {Temporarily block ads              }
    DisableControls;
    { Die Anzahl der Datensätze übernehmen }
    { Apply the number of records          }
    i:= ZQuery2.RecordCount;
    { Und so oft den Löschvorgang aufrufen, bis alle Datensätze gelöscht sind }
    { And call the deletion until all records are deleted                     }
    for i:=0 to i-1 do begin
      Delete;
    end;
    { Die Datenanzeige wieder verwenden }
    { Reuse the data display            }
    EnableControls;
  end;

end;


end.



