unit LemRoutines;

{$mode objfpc}{$H+}

interface

uses  SysUtils, IniFiles, Forms, Graphics, Dialogs,
  Classes, StdCtrls, Interfaces;

{ **************************************************************************** }
{ * GLOBALE DEFINES                                                          * }
{ *****************************************************************************}

{  .$define DEMO}

{ **************************************************************************** }
{ * GLOBALE TYPEN-Deklarationen                                              * }
{ *****************************************************************************}

type

  string8 = string

    [8];
  ShortString = string;
  PShortString = pstring;
  EMyException = class(Exception);


{ **************************************************************************** }
{ * GLOBALE CONST-Deklarationen                                              * }
{ *****************************************************************************}

const

  MAX = 'MAX';

{=====================================================}
{ verwendete Standardtasten                           }
{=====================================================}

{ F1    Hilfe                            WIN-Standard }

{ F2    stellt um auf Editiermodus       WIN-Standard }
// VKL_EDIT      = VK_F2;

{ F3 startet Suche im jeweiligen Zusammenhang         }
// VKL_SEARCH    = VK_F3;

{ F4 Taste für Überblendungen }
// VKL_UEBERBL   = VK_F4;

{ F5 Sprung auf den obersten, mittleren, unteren Bildschirmteil }
// VKL_TOP       = VK_F5;
// VKL_MIDDLE    = VK_F6;
// VKL_BOTTOM    = VK_F7;
// VKL_UEBERNAHME= VK_F7;

{ F8 Umschalttaste zwischen Listen- und Formularanzeige  }
// VKL_LIST      = VK_F8;

{ F9 legt neuen Datensatz an }
// VKL_NEWREC    = VK_F9;

{ F10 Menübalken aufrufen }

{ F11 und F12 Datenbanknavigation }
// VKL_PREVREC   = VK_F11;
// VKL_NEXTREC   = VK_F12;


{ **************************************************************************** }
{ * GLOBALE VARIABLEN-Deklarationen                                          * }
{ *****************************************************************************}

var

  { um mögliche spätere Implemtierungen für andere DB zu erleichtern }
  DBProtocol: string;

{ **************************************************************************** }
{ * GLOBALE PROEDURE und FUNCTION                                            * }
{ *****************************************************************************}

{ Glonale Parameter gültig für alle Programme }
procedure SetGlobalParameters;
{ Vereinfachtes lesen von INI-Daten }
function LemIniRead(var LemIniFile, LemIniSection, LemIniKey: string): string;
function GlobIniRead(var LemIniSection, LemIniKey: string): string;
{ Vereinfachtes Schreiben von INI-Dateien }
function LemIniWrite(var LemIniFile, LemIniSection, LemIniKey,
  LemIniValue: string): string;
function GlobIniWrite(var LemIniSection, LemIniKey, LemIniValue: string): string;


implementation

{ **************************************************************************** }
{ * LEMINIREAD vereinfachtes lesen von INI-Daten                              * }
{ **************************************************************************** }
function LemIniRead(var LemIniFile, LemIniSection, LemIniKey: string): string;

var
  List: TiniFile;
  LemVal: string;
  le: integer;

begin
  List := TIniFile.Create(LemIniFile + '.ini');
  LemVal := List.ReadString(LeminiSection, LemIniKey, '');
  List.Free;
  le := Length(LemVal) - 2;
  LemVal := Copy(LemVal, 2, le);
  LemIniRead := LemVal;
end;

{ **************************************************************************** }
{ * GLOBINIREAD vereinfachtes lesen von INI-Daten ohne Dateinamenparameter   * }
{ **************************************************************************** }
function GlobIniRead(var LemIniSection, LemIniKey: string): string;

var
  s: string;

begin
  s := Application.Title;
  GlobIniRead := LemIniRead(s, LemIniSection, LemIniKey);
end;

{ **************************************************************************** }
{ * LEMINIWRITE vereinfachtes schreiben von INI-Daten                        * }
{ **************************************************************************** }
function LemIniWrite(var LemIniFile, LemIniSection, LemIniKey, LemIniValue:
  string): string;

var
  List: TiniFile;
  LemVal: string;
begin
  LemVal := '"' + LemIniValue + '"';
  List := TIniFile.Create(LemIniFile + '.ini');
  List.WriteString(LemIniSection, LemIniKey, LemVal);
  List.Free;
  LemIniWrite := LemIniValue;
end;

{ **************************************************************************** }
{ * GLOBINIWRITE vereinfachtes lesen von INI-Daten ohne Dateinamenparameter   * }
{ **************************************************************************** }
function GlobIniWrite(var LemIniSection, LemIniKey, LemIniValue: string): string;

var
  s: string;

begin
  s := Application.Title;
  LemIniWrite(s, LemIniSection, LemIniKey, LemIniValue);
  GlobIniWrite := LemIniValue;
end;


{ **************************************************************************** }
{ * SETGLOBALPARAMETERS wird beim Pogrammstart einmal aufgerufen um alle für * }
{ * das Programm benötigten Einstellungen und Globale Variablen zu initieren * }
{ **************************************************************************** }
procedure SetGlobalParameters;
begin
  // https://lazarus-ccr.sourceforge.io/docs/lcl/forms/tapplication.html
  // https://wiki.freepascal.org/Command_line_parameters_and_environment_variables
  // Wert für DBProtocol setzen
  // DBProtocol := 'firebird';
end;


{ **************************************************************************** }
{ *                             INITIALIZATION                               * }
{ **************************************************************************** }
initialization
  { die globalen Einstellungen aufrufen }
  SetGlobalParameters;

end.
